VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmDatenPaare 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Temperaturdiagramm (Daten)"
   ClientHeight    =   6210
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   12720
   LinkTopic       =   "Form1"
   ScaleHeight     =   6210
   ScaleWidth      =   12720
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton btnDtnCheck 
      Caption         =   "Dateneingabe abschlieen"
      Height          =   525
      Left            =   7680
      TabIndex        =   8
      Top             =   4560
      Width           =   2535
   End
   Begin VB.CommandButton btnEnde 
      Caption         =   "Ende"
      Height          =   510
      Left            =   11040
      TabIndex        =   6
      Top             =   4560
      Width           =   1215
   End
   Begin VB.CommandButton btnDiagram 
      Caption         =   "Diagramm"
      Enabled         =   0   'False
      Height          =   510
      Left            =   11040
      TabIndex        =   4
      Top             =   3000
      Width           =   1215
   End
   Begin VB.CommandButton btnDtnRead 
      Caption         =   "Daten lesen"
      Height          =   510
      Left            =   11040
      TabIndex        =   3
      Top             =   2040
      Width           =   1215
   End
   Begin VB.CommandButton btnDtnSave 
      Caption         =   "Daten speichern"
      Enabled         =   0   'False
      Height          =   510
      Left            =   11040
      TabIndex        =   2
      Top             =   1080
      Width           =   1215
   End
   Begin VB.TextBox txtDatenPaare 
      Height          =   2775
      Left            =   7680
      MultiLine       =   -1  'True
      TabIndex        =   1
      Text            =   "frmDatenPaare.frx":0000
      Top             =   1320
      Width           =   2535
   End
   Begin MSComDlg.CommonDialog fdiaDateiAuswahl 
      Left            =   8880
      Top             =   2520
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label lblHinweis 
      BackColor       =   &H00C0C0C0&
      Height          =   5775
      Left            =   360
      TabIndex        =   0
      Top             =   240
      Width           =   6855
   End
   Begin VB.Label lblTitelzuTxtDatenPaare 
      BackColor       =   &H00C0C0C0&
      Caption         =   "Monat     ;     Temperatur"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   7800
      TabIndex        =   7
      Top             =   1020
      Width           =   2295
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Zentriert
      BackColor       =   &H00C0C0C0&
      Height          =   555
      Left            =   7440
      TabIndex        =   5
      Top             =   3960
      Width           =   3135
   End
End
Attribute VB_Name = "frmDatenPaare"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const dateiTyp = ".MOTE"
Const maxDatenPaare As Integer = 12

Const maxTemp As Single = 40
Const minTemp As Single = -30

Private Type datenPaareSatz
  monat As String
  temperatur As Single
End Type
Dim datenPaar(maxDatenPaare) As datenPaareSatz            'Google sei Dank: Datenfeld definiert mit maxDatenPaare-Anzahl als Gre
Dim datenPaareDatei As String

Dim errNr As Long
Dim anzSemis As Integer
Dim anzNewLines As Integer
Dim eingabeFehler As Boolean
Dim zeichenLaenge As Integer





'***********************************************************************************
Private Sub Form_Load()
  lblHinweis.Caption = "Das Programm -DatenPaare- speichert Ihre eingegebenen Daten in Paaren in einer Randomdatei des Types -MOTE-" _
 & ", die Sie bentigen, um sich Ihre Daten als Grafik anzeigen zu lassen. Dazu ist es notwendig, dass Sie folgende Regeln bei der Eingabe beachten: " _
 + vbNewLine + vbNewLine + " Sie knnen 12 Datenpaare eingeben (je eine Monat mit der dazugehrigen Temperatur). " _
 + vbNewLine + " Die Dateneingabe muss in diesem Format erfolgen: mmm;#0,000" + vbNewLine + " Die Monatsbezeichnung -mmm- muss min. drei Zeichen enthalten und darf sich nicht wiederholen." _
 + vbNewLine + " Monat und Temperatur muss mit einem -;- getrennt werden." + vbNewLine + " Die Temperatur muss im Intervall von 40 bis -30C liegen und kann drei Nachkommastellen haben." _
 + vbNewLine + " Der Temperaturwert muss mit Komma statt Punkt geschrieben werden." + vbNewLine + " Jedes Paar muss in eine extra Zeile im Textfeld geschrieben werden." _
 + vbNewLine + " Jede Zeile muss mit -Return- beendet werden." + vbNewLine + " berzhlige Zeichen des Monats oder Nachkommastellen" _
 + "der Temperatur werden abgeschnitten." + vbNewLine + vbNewLine + " Haben Sie die Eingabe der 12 Datenpaare beendet, drcken Sie bitte den Knopf - Dateneingabe abschlieen-." _
 + " Daraufhin fhrt das Programm eine berprfung der Eingabe durch und bittet Sie gegebenenfalls Fehler zu korrigieren. Ist die Prfung erfolgreich verlaufen, wird der Knopf -Daten speichern- aktiviert." _
 + "Bei dessen Bettigung speichern Sie Ihre Daten in einer Randomdatei, die Sie im erscheinenden Fenster auswhlen oder erstellen knnen. " + vbNewLine + " Nach erfolgreicher Speicherung aktiviert sich der Knopf -Diagramm- ber" _
 + " den Sie zu der graphischen Darstellung Ihrer Daten gelangen. Ist bereits eine -MOTE--Datei vorhanden, knnen Sie diese ber den Knopf -Daten lesen- suchen und aufrufen. Die Daten werden im Textfeld sichtbar," _
 + "und Sie haben die Mglichkeit, nderungen durchzufhren. Diese mssen allerdings ebenfalls erst geprft und neu abgespeichert werden, bevor Sie sie im Diagramm betrachten knnen. " + vbNewLine + _
 vbNewLine + " Viel Erfolg mit -DatenPaare-!"
End Sub

Private Sub btnDtnCheck_Click()
  Dim anzSemis As Integer
  Dim anzNewLines As Integer

  lblStatus.Caption = ""
  If trennZchnOk(txtDatenPaare, anzSemis, anzNewLines) Then
    If monatsEingabeOk(txtDatenPaare, datenPaar) Then
      If numEingabeOk(txtDatenPaare, datenPaar) Then
       btnDtnSave.Enabled = True
      End If
    End If
  End If
End Sub

Private Sub btnDtnSave_Click()          ' Btn Daten speichern
Dim i As Integer
'Debug.Print "dateiname: " + dateiName
If dateiName = "" Then                   'falls keine Datei ausgewhlt
 Exit Sub
Else
 datenPaareDatei = dateiName             'Pfad  + name
 Open datenPaareDatei For Random As #1  'Len = Len(data)
 For i = 0 To maxDatenPaare - 1
  Put #1, i + 1, datenPaar(i)           'zeilenweise abspeichern
 Next
 Close #1
 btnDiagram.Enabled = True
 lblStatus.Caption = "Datenspeicherung erfolgreich abgeschlossen!"
End If
End Sub
Private Sub btnDtnRead_Click()  'Btn Daten lesen
Dim i As Integer
  
lblStatus.Caption = ""
datenPaareDatei = dateiName             'Funktion fr Dateiauswahlfenster
 
If datenPaareDatei = "" Then            'falls keine Datei ausgewhlt
 Exit Sub
Else
 txtDatenPaare.Text = ""                'Textfeld lschen
 Cls
 Open datenPaareDatei For Random As #1  'Len = Len(data)
 For i = 0 To maxDatenPaare - 1
 Get #1, i + 1, datenPaar(i)            'zeilenweise lesen
 txtDatenPaare.Text = txtDatenPaare.Text + datenPaar(i).monat + ";" + CStr(datenPaar(i).temperatur) + vbNewLine
 Next                                   'als string wieder hinschreiben
 Close #1
End If
  btnDtnSave.Enabled = True
  btnDiagram.Enabled = True
End Sub
Private Function monatsEingabeOk(ByVal txtDatenFeld As Object, ByRef datenPaar() As datenPaareSatz) As Boolean
  Dim datenPaarZeile() As String
  Dim monatsString As String
  Dim posSemi As Integer
  Dim monats As String
  Dim monatDoppelt As Integer
  Dim i As Integer
  Dim j As Integer
  Dim fehler As Boolean
 
  monatsEingabeOk = True
  posSemi = 1
  zeichenLaenge = 0

  datenPaarZeile = Split(txtDatenFeld.Text, vbNewLine)       'Lob an Google! spaltet Text in Zeilen am return
  
  For i = 0 To maxDatenPaare - 1                             'Schleife: zeilenweise spalten
Debug.Print datenPaarZeile(i)

  zeichenLaenge = zeichenLaenge + Len(datenPaarZeile(i + 1)) + 2
  If InStr(datenPaarZeile(i), ";") Then                       'falls kein Semikolon in der Zeile
  If InStr(posSemi, datenPaarZeile(i), ";") > 0 Then          'falls kein monat eingegeben
  posSemi = InStr(posSemi, datenPaarZeile(i), ";") - 1        'findet ";" und merkt sich Position
  monatsString = Left$(datenPaarZeile(i), posSemi)            'links neben ";" = monat
  monats = Trim$(monatsString)                                'monat ohne Leerzeichen
Debug.Print "-"; monats; "-"
  Else
    txtDatenPaare.SetFocus
    monatsEingabeOk = False
    fehler = datenFehlerGemeldet(txtDatenPaare, "Monatsbezeichnung fehlt!", ">>>   min. 3 Zeichen eingeben!")
    Exit Function
  End If
  Else
    txtDatenPaare.SetFocus
    monatsEingabeOk = False
    fehler = datenFehlerGemeldet(txtDatenPaare, "Semikolon fehlt in dieser Zeile!", ">>>   Datenpaar mit Semikolon trennen!")
    Exit Function
  End If
  If Len(monats) < 3 Then                                     'meckern bei weniger als 3 Zeichen
    txtDatenPaare.SetFocus
    monatsEingabeOk = False
    fehler = datenFehlerGemeldet(txtDatenPaare, "In der Zeile ist die Monatsbezeichnung zu kurz!", ">>>   mind. drei Zeichen eingeben!")
    Exit Function
  End If
  If Len(monats) > 3 Then                                     'nach 3 Zeichen abschneiden
  monats = Left$(datenPaarZeile(i), 3)
  End If
  For j = 0 To i - 1                                          'Prfung, ob Monat doppelt: Schleife in Schleife: erst vom Anfang bis jetzige Zeile
   monatDoppelt = InStr(datenPaarZeile(j), monats)
   If monatDoppelt > 0 Then
    txtDatenPaare.SetFocus
    monatsEingabeOk = False
    fehler = datenFehlerGemeldet(txtDatenPaare, "Die Monatsbezeichnung ist doppelt!", ">>>   andere Bezeichnung eingeben!")
    Exit Function
   End If
  Next
  For j = i + 1 To maxDatenPaare - 1                          'Prfung, ob Monat doppelt: dann von jetziger Zeile bis Ende Text
   monatDoppelt = InStr(datenPaarZeile(j), monats)
   If monatDoppelt > 0 Then
    txtDatenPaare.SetFocus
    monatsEingabeOk = False
    fehler = datenFehlerGemeldet(txtDatenPaare, "Die Monatsbezeichnung ist doppelt!", ">>>   andere Bezeichnung eingeben!")
    Exit Function
   End If
  Next
datenPaar(i).monat = monats                                   'nach Prfung in Datenfeld schreiben
Next                                                          'Schleife zu ende

End Function

Private Function numEingabeOk(ByVal txtDatenFeld As Object, ByRef datenPaar() As datenPaareSatz) As Boolean
  Dim datenPaarZeile() As String
  Dim tempWert As String
  Dim tempZahl As String
  Dim tZahl As Single
  Dim posNewLine As Integer
  Dim posSemi As Integer
  Dim tZahlLong As Long
  Dim fehler As Boolean
  Dim i As Integer

  posNewLine = 1
  posSemi = 1
  zeichenLaenge = 0

  datenPaarZeile = Split(txtDatenFeld.Text, vbNewLine)        'Lob an Google! spaltet Text in Zeilen am return
  
  For i = 0 To maxDatenPaare - 1                              'Schleife: zeilenweise spalten
   posNewLine = InStr(posNewLine, txtDatenFeld.Text, Chr(Asc(vbNewLine))) + 1     'Position return
   posSemi = InStr(posSemi, datenPaarZeile(i), ";") - 1       'Position ";"
   tempWert = Mid$(datenPaarZeile(i), posSemi + 2, posNewLine - posSemi - 1)      'Temperatur = nach ";" und Position return minus Position ";" lang
   zeichenLaenge = zeichenLaenge + Len(datenPaarZeile(i + 1)) + 2
 
  tempZahl = Trim(tempWert)                                   'Leerzeichen weg
  If Len(tempZahl) = 0 Then
   txtDatenPaare.SetFocus
   numEingabeOk = False                                       'meckern wenn nix geschrieben
   fehler = datenFehlerGemeldet(txtDatenPaare, "Die Temperatureingabe fehlt!", ">>>   Temperatur eingeben!")
   Exit Function
  ElseIf InStr(1, tempZahl, ".") Then                         'EingabeOk
   numEingabeOk = False
   fehler = datenFehlerGemeldet(txtDatenPaare, "falsches Trennzeichen!", ">>>   Bitte nur Trennzeichen """", """" eingeben!")
   txtDatenPaare.SetFocus
   numEingabeOk = False
   Exit Function
  ElseIf InStr(1, tempZahl, "(") Or InStr(1, tempZahl, ")") Then
   fehler = datenFehlerGemeldet(txtDatenPaare, "falsche Temperatureingabe!", ">>>   Bitte nur Ziffern 0-9 eingeben!")
   txtDatenPaare.SetFocus
   numEingabeOk = False
   Exit Function
  ElseIf Not IsNumeric(tempZahl) Then
   fehler = datenFehlerGemeldet(txtDatenPaare, "falsche Temperatureingabe!", ">>>   Bitte nur Ziffern 0-9 eingeben!")
   txtDatenPaare.SetFocus
   numEingabeOk = False
   Exit Function
  ElseIf InStr(1, tempZahl, ",") Then                         'Komma intern ersetzen
    tempZahl = Replace(tempZahl, ",", ".")
  End If
  On Error Resume Next
  tZahl = Val(tempZahl)                                       'in Zahl umwandeln
  errNr = Err.Number
  On Error GoTo 0
  If errNr <> 0 Then
   Select Case errNr
   Case 6
   numEingabeOk = False
   fehler = datenFehlerGemeldet(txtDatenPaare, "Zahl zu gro!", ">>>   Temperaturen mssen zwischen 40 und -30C liegen!")
   Exit Function
   Case Else
    MsgBox "unbekannter Fehler!"
   End Select
   numEingabeOk = False
   Exit Function
   Else
    numEingabeOk = True
   End If
   If tZahl > maxTemp Or tZahl < minTemp Then                          'Prfung, ob Temp im Intervall
   fehler = datenFehlerGemeldet(txtDatenPaare, "Temperaturwert liegt nicht im Intervall!", ">>>   Temperaturen mssen zwischen 40 und -30C liegen!")
    txtDatenPaare.SetFocus
    numEingabeOk = False
    Exit Function
   Else
    tZahl = tZahl * 1000                                      'irgendwie auf 3 Nachkommastellen trimmen
    tZahlLong = CLng(tZahl)
    tZahl = tZahlLong / 1000
   End If

datenPaar(i).temperatur = tZahl                               'nach Prfung in Datenfeld schreiben
Debug.Print "-"; datenPaar(i).temperatur; "-"
Next                                                          'Schleife zu ende

End Function

Private Function datenFehlerGemeldet(txtDatenPaare As Object, ByVal fehlerTxt As String, ByVal hinweisTxt As String) As Boolean
  
  txtDatenPaare.SetFocus
  txtDatenPaare.SelStart = zeichenLaenge
  MsgBox fehlerTxt + vbNewLine + vbNewLine + hinweisTxt
  datenFehlerGemeldet = True
End Function
  
 
Private Sub txtDatenPaare_Change()
 btnDtnSave.Enabled = False                                   'wenn Textfeld gendert
 btnDiagram.Enabled = False                                   'Btn ausschalten
 lblStatus.Caption = ""                                       'u. Anzeige lschen
End Sub

Private Function dateiName() As String        'liefert Dateiname einschlielich Pfad + Laufwerk
  On Error Resume Next
    fdiaDateiAuswahl.CancelError = True                        'fkt. kopiert aus ProSplit
    fdiaDateiAuswahl.DialogTitle = "Datei auswhlen"
    fdiaDateiAuswahl.Filter = ".MOTE | *.MOTE"
    fdiaDateiAuswahl.Flags = cdlOFNFileMustExist
    fdiaDateiAuswahl.ShowOpen
    If Err = 0 Then
      dateiName = fdiaDateiAuswahl.FileName
    Else
      dateiName = ""
    End If
  On Error GoTo 0
End Function


'***********************************************************************************
Private Sub btnDiagram_Click()
  frmDiagram.Visible = True
  frmDatenPaare.Visible = False
End Sub


  

Private Sub btnEnde_Click()
  End
End Sub
Private Function fehlerGemeldet(txtDatenPaare As Object, ByVal fehlerTxt As String, ByVal hinweisTxt As String, ByVal anfZle As Integer, ByVal endeZle As Integer) As Boolean
  Dim posSemi As Integer
  Dim posNewLine As Integer
  Dim anzSemis As Integer
  Dim anzNewLines As Integer
  
Debug.Print "anfZle " & anfZle
Debug.Print "endeZle " & endeZle
  txtDatenPaare.SetFocus
  txtDatenPaare.SelStart = anfZle
  If anfZle > endeZle Then
    txtDatenPaare.SelStart = endeZle
  End If
  MsgBox fehlerTxt + vbNewLine + vbNewLine + hinweisTxt
  fehlerGemeldet = True
End Function

Private Function trennZchnOk(txtDatenFeld As Object, ByRef anzSemis As Integer, ByRef anzNewLines As Integer) As Boolean
  Dim posSemi As Integer
  Dim posNewLine As Integer
  Dim anfZle As Integer
  Dim endeZle As Integer
  
  Dim fehler As Boolean
  trennZchnOk = True
  
  posSemi = 1
  posNewLine = 1
  anfZle = 0
  endeZle = 1
  anzSemis = 0
  anzNewLines = 0
  
  While (InStr(posSemi, txtDatenFeld.Text, ";") > 0) Or (InStr(posNewLine, txtDatenFeld.Text, vbNewLine) > 0)
    If (InStr(posSemi, txtDatenFeld.Text, ";") > 0) Then
      anzSemis = anzSemis + 1
      posSemi = InStr(posSemi, txtDatenFeld.Text, ";") + 1
      endeZle = posSemi
    End If
    If (InStr(posNewLine, txtDatenFeld.Text, Chr(Asc(vbNewLine))) > 0) Then
      anzNewLines = anzNewLines + 1
      posNewLine = InStr(posNewLine, txtDatenFeld.Text, Chr(Asc(vbNewLine))) + 1
'      endeZle = posNewLine - 1     funktioniert nicht so recht1
      endeZle = posNewLine - 2
    End If
    If (anzSemis < anzNewLines) Or ((posSemi > posNewLine) And (anzSemis = anzNewLines)) Then
      fehler = fehlerGemeldet(txtDatenPaare, "in der Zeile fehlt ein Semikolon!", ">>>   Semikolon eingeben!", anfZle, endeZle)
      trennZchnOk = False
    Exit Function
    End If
    If ((anzSemis > anzNewLines + 1) And (posNewLine < posSemi)) Or ((anzSemis > anzNewLines) And (posNewLine > posSemi)) Then
      fehler = fehlerGemeldet(txtDatenPaare, "in der Zeile ist ein (oder mehrere) Semikolon zu viel!", ">>>   Semikolon lschen!", anfZle, endeZle)
      trennZchnOk = False
      Exit Function
    End If
    If (anzSemis > maxDatenPaare) Or (anzNewLines > maxDatenPaare) Then
      fehler = fehlerGemeldet(txtDatenPaare, "Zu viele Zeilen!", ">>>   nur 12 Zeilen/ Datenpaare eingeben!", anfZle, endeZle)
      trennZchnOk = False
      Exit Function
    End If
  anfZle = posNewLine
  endeZle = posNewLine
  Wend
  If (anzSemis < maxDatenPaare) Or (anzNewLines < maxDatenPaare) Then
    fehler = fehlerGemeldet(txtDatenPaare, "Zeilen fehlen!", ">>>   bitte 12 Zeilen/ Datenpaare eingeben!", anfZle, endeZle)
    trennZchnOk = False
  End If
  If (anzSemis >= maxDatenPaare) Or (anzNewLines >= maxDatenPaare) Then
    If Len(txtDatenFeld.Text) > endeZle Then
      fehler = fehlerGemeldet(txtDatenPaare, "zu viele Daten!", ">>>   nur 12 Zeilen/ Datenpaare eingeben!", anfZle, endeZle)
      trennZchnOk = False
    End If
  End If
Debug.Print "anfZle " & anfZle
Debug.Print "nach while posSemi " & posSemi & " anzSemis " & anzSemis
Debug.Print "nach while posNL " & posNewLine & " anzNL " & anzNewLines
End Function

